cprog sock_sendmsg = sock_sendmsg {
    abstract sock_sendmsg_01,{1},Sock_Sendmsg;
}

cproc scm_send {
    abstract {scm_send_abs,1,ScmSend};
}

cproc sendmsg {
    abstract {sendmsg_abs,1,Sendmsg};
}

cproc scm_destroy {
    abstract {scm_destroy_abs,1,ScmDestroy};
}

cproc sock_sendmsg {
    predicate (err == -1),(err >= 0);

    alias {sock->ops->sendmsg,sendmsg};

    abstract {sock_sendmsg_01,1,Sock_Sendmsg};
}

ScmSend = ( scm_send -> return {1} -> STOP | error -> return {-1} -> STOP ).

Sendmsg = ( send -> return {1} -> STOP | error -> return {-1} -> STOP ).

ScmDestroy = ( scm_destroy -> return {} -> STOP ).

Sock_Sendmsg = ( scm_send -> Scm_Sent | error -> return {-1} -> STOP ),
Scm_Sent = ( send -> scm_destroy -> return {1} -> STOP | error -> scm_destroy -> return {-1} -> STOP ).

