cprog sys_socket = sys_socket {
    abstract socket_01,{1},Socket;
}

cproc sock_release {
    abstract {sock_release_abs,1,SockRelease};
}

cproc create {
    abstract {create_abs,1,Create};
}

cproc sys_socket {
    predicate (retval < 0);

    inline sock_create;

    abstract {socket_01,1,Socket};
}

cproc sock_alloc {
    abstract {sock_alloc_abs,1,SockAlloc};
}

cproc sock_create {
    predicate (i < 0);
    predicate (sock == 0);
    alias {net_families[family]->create,create};
}

cproc sock_map_fd {
    abstract {sock_map_fd_abs,1,SockMapFd};
}

Create = ( create -> return {1} -> STOP | return {-1} -> STOP ).

SockRelease = ( release -> return {} -> STOP ).

SockAlloc = ( alloc -> return {1} -> STOP | return {0} -> STOP ).

SockMapFd = ( return {1} -> STOP | return {-1} -> STOP ).

Socket = ( alloc -> Allocated | return {-1} -> STOP | return {-97} -> STOP | return {-22} -> STOP | return {-23} -> STOP ),
Allocated = ( create -> Created | release -> return {-1} -> STOP ),
Created = ( release -> return {-1} -> STOP | return {1} -> STOP ).

