/**************************** CPPHeaderFile ***************************

* FileName [CEGen.h]

* PackageName [main]

* Synopsis [Header file for CEGen class.]

* Description [This class encapsulates the counterexample generator.]

* SeeAlso [CEGen.cpp]

* Author [Sagar Chaki]

* Copyright [ Copyright (c) 2002 by Carnegie Mellon University.  All
* Rights Reserved. This software is for educational purposes only.
* Permission is given to academic institutions to use, copy, and
* modify this software and its documentation provided that this
* introductory message is not removed, that this software and its
* documentation is used for the institutions' internal research and
* educational purposes, and that no monies are exchanged. No guarantee
* is expressed or implied by the distribution of this code. Send
* bug-reports and/or questions to: chaki+@cs.cmu.edu. ]

**********************************************************************/

#ifndef __CEGEN_H__
#define __CEGEN_H__

class CEGen
{
 private:
  static void RunFsp();
  static void RunLtl();

 public:
  static void Run();
};

#endif //__CEGEN_H__

/*********************************************************************/
//end of CEGen.h
/*********************************************************************/
